﻿Imports System.IO
Imports System.Data

Module Module1

    Sub Main()
        Dim input As String
        Do
            'Print text to console window:
            Console.Write("Please enter your date of birth (mm/dd/yyyy): ")

            'Read user's keyboard input and store into variable 'input'
            input = Console.ReadLine

            'Branch conditionally
            If input = "time" Then
                Console.WriteLine("At the tone, the time will be: " & Date.Now.ToShortTimeString)
                Console.WriteLine()
                Beep()
            ElseIf input = "today" Then
                Console.WriteLine("Today is {0}, the {1}",
                                  Now.ToString("dddd"),
                                  Now.ToString("MMMM, dd. yyyy"))
                Console.WriteLine()
            Else
                If input IsNot Nothing AndAlso input.Length > 6 Then
                    Try
                        Dim yearOfBirth As Date
                        Dim age As Integer

                        'Convert string of characters into a real date:
                        yearOfBirth = Date.Parse(input)
                        'call a function to calculate a value
                        age = CalcAge(yearOfBirth)
                        Console.WriteLine("You are {0} years old!", age)
                        Console.WriteLine()
                        Console.WriteLine()
                    Catch ex As Exception
                        Console.WriteLine("Error: Your input wasn't" &
                                          "of the right date format!")
                        Console.WriteLine(ex.Message)
                        Console.WriteLine()
                    End Try
                End If
            End If
            'As long as user didn't just press return, loop commands between do and loop.
        Loop While Not String.IsNullOrWhiteSpace(input)
    End Sub

    ''' <summary>
    ''' Calculates the age in years from a given date.
    ''' </summary>
    ''' <param name="yearOfBirth">The date of birth used for the calculation of the age.</param>
    ''' <returns>The age in years.</returns>
    ''' <remarks>There is nothing to remark, here.</remarks>
    Function CalcAge(yearOfBirth As Date) As Integer
        Dim ageToReturn As Integer
        Dim today As Date = Date.Today
        Dim diffToDateOfBirth As TimeSpan

        diffToDateOfBirth = today.Subtract(yearOfBirth)
        ageToReturn = diffToDateOfBirth.Days \ 365
        Return ageToReturn
    End Function
End Module
