Option Strict On

Imports System.Net.Mail
Imports System.ComponentModel

Public Class frmMainForm

    Private myPicFileName As String

    Private Sub btnPrintInlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrintInlay.Click

        'The structure FontSettings that contains all the font settings is
        'read from the settings file.

        'Read the individual Cover data elements from the controls
        Dim locCoverContent As New CoverContent
        locCoverContent.MovieTitle = txtNameoftheMovie.Text
        locCoverContent.Actor = txtActor.Text
        locCoverContent.Description = txtDescription.Text
        locCoverContent.CoverImage = picCoverPic.Image

        'Calls the print preview:
        'We need a new instanz of the form for that.
        'It would be possible to use the class without instantiation - 
        'but that is not OOP and will be boycotted ;-)
        Dim locPrintCoverForm As New frmPrintCover
        locPrintCoverForm.RepresentDialouge(locCoverContent)
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        Me.Close()
        Me.DialogResult = Windows.Forms.DialogResult.OK
    End Sub

    Private Sub btnPickCoverPic_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPickCoverPic.Click
        'New instance of the OpenFileDialog
        Dim locOfd As New OpenFileDialog

        'Set the parameter for the OpenFileDialog
        With locOfd
            locOfd.CheckFileExists = True
            locOfd.DefaultExt = "*.bmp"
            locOfd.Filter = "JPeg-Bilder (*.jpg)|*.jpg|Windows Bitmap (*.bmp)|*.bmp|All Files (*.*)|*.*"

            'Show the OpenFileDialog
            Dim locDr As DialogResult = locOfd.ShowDialog()
            'When cancel is clicked...
            If locDr = Windows.Forms.DialogResult.Cancel Then
                '...do nothing.
                Return
            End If

            'Saves the PicFileName at the end of the program
            myPicFileName = locOfd.FileName

            'New Image-object, made out of the image file
            picCoverPic.Image = CoverFromImage(myPicFileName)

        End With
    End Sub

    Private Sub btnDeleteInput_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeleteInput.Click
        'DialogResult is an enum, which saves dialogbox-"results".
        Dim locDr As DialogResult
        'Ask if you want to delete.
        locDr = MessageBox.Show("Are you sure?", "Delete input?", _
                 MessageBoxButtons.YesNo, _
                 MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)
        'Clear the control's content, when yes is pressed
        If locDr = Windows.Forms.DialogResult.Yes Then
            txtDescription.Text = ""
            txtNameoftheMovie.Text = ""
            txtActor.Text = ""
            myPicFileName = ""
            picCoverPic.Image = Nothing
        End If
    End Sub

    'The main form is closing -
    'the user's entries will be saved in the settings
    Private Sub frmMainForm_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        My.Settings.LastDescription = txtDescription.Text
        My.Settings.LastMovieName = txtNameoftheMovie.Text
        My.Settings.LastActor = txtActor.Text
        My.Settings.LastCoverPicFileName = myPicFileName
    End Sub

    Private Sub frmMainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtDescription.Text = My.Settings.LastDescription
        txtNameoftheMovie.Text = My.Settings.LastMovieName
        txtActor.Text = My.Settings.LastActor
        myPicFileName = My.Settings.LastCoverPicFileName
    End Sub

    ''' <summary>
    ''' Loads an Image(if avaiable) from a file and returns the picture as an Image object (or returns Nothing).
    ''' </summary>
    ''' <param name="CoverpicFileName">Name of the image file</param>
    ''' <returns>Image from the Imagefile with the given name as image-object.</returns>
    ''' <remarks>Originally created by Klaus Lffelmann at 10/26/2005 for Microsoft Press: Visual Basic - Das Entwicklerbuch.</remarks>
    Function CoverFromImage(ByVal CoverpicFileName As String) As Image
        Dim locImage As Image
        If CoverpicFileName IsNot Nothing AndAlso CoverpicFileName <> "" Then
            locImage = Image.FromFile(CoverpicFileName)
            Return locImage
        End If
        Return Nothing
    End Function

End Class


