﻿Module mainModule

    Dim LastName(0 To 100) As String
    Dim FirstName(0 To 100) As String
    Dim ZIP(0 To 100) As String
    Dim City(0 To 100) As String

    Sub Main()

        'Just for a change...a variation of colors in the Console Window! :-)
        Console.BackgroundColor = ConsoleColor.White
        Console.ForegroundColor = ConsoleColor.Black
        Console.Clear()

        'Generate random addresses.
        Console.Write("Generating random addresses ... ")
        GenerateRandomAddresses()
        Console.WriteLine("Ready!")

        'Print the first 10 addresses.
        PrintAddresses(0, 10)

        'Sort the addresses
        Console.WriteLine()
        Console.Write("Addresses are being sorted ... ")
        SortAddresses()
        Console.WriteLine("ready!")
        Console.WriteLine()

        'Print the first 10 addresses yet again.
        PrintAddresses(0, 10)

        'Wait for the program to be finished.
        Console.WriteLine()
        Console.WriteLine("Press any key...")
        Console.ReadKey()

    End Sub

    Sub PrintAddresses(ByVal von As Integer, ByVal bis As Integer)
        For c As Integer = von To bis
            Console.WriteLine(c.ToString("000") & ": " & LastName(c) & ", " & FirstName(c) & _
                              ", " & ZIP(c) & ", " & City(c))
        Next
    End Sub

    Sub SortAddresses()

        'Example for local type inference
        Dim itemCount = 101
        Dim delta = 1

        Dim outerCounter As Integer
        Dim innerCounter As Integer

        Dim tempFirstName, tempLastName, tempZIP, tempCity As String

        'Greatest value in distance sequence
        Do
            delta = 3 * delta + 1
        Loop Until delta > itemCount

        Do
            delta \= 3

            'Base algorithm of shellsort
            For outerCounter = delta To itemCount - 1
                tempFirstName = FirstName(outerCounter)
                tempLastName = LastName(outerCounter)
                tempZIP = ZIP(outerCounter)
                tempCity = City(outerCounter)

                innerCounter = outerCounter
                Do
                    If tempLastName >= LastName(innerCounter - delta) Then Exit Do
                    FirstName(innerCounter) = FirstName(innerCounter - delta)
                    LastName(innerCounter) = LastName(innerCounter - delta)
                    ZIP(innerCounter) = ZIP(innerCounter - delta)

                    innerCounter = innerCounter - delta
                    If (innerCounter <= delta) Then Exit Do
                Loop
                FirstName(innerCounter) = tempFirstName
                LastName(innerCounter) = tempLastName
                City(innerCounter) = tempCity
            Next
        Loop Until delta = 0
    End Sub

    Public Sub GenerateRandomAddresses()

        Dim locRandom As New Random(Now.Millisecond)

        Dim locLastNames As String() = {"Heckhuis", "Löffelmann", "Jones", "Lowel", _
                    "Ardelean", "Beckham", "Baur", "Picard", "Trouv", "Feigenbaum", _
                    "Miller", "Wallace", "Merkel", "Spooner", "Spoonman", "Huffman", _
                    "Rode", "Trouw", "Schindler", "Brown", "Walker", "Cruise", _
                    "Tinoco", "O'Reilly", "O'Donnell", "Ó Briain", "Russel", "English", _
                    "Clarke", "Schumacher"}

        Dim locStreetNames As String() = {"Wiedenbrückerstr.", "Stauffenberg Ave.", "Broadway", "Parkstr.", _
                         "Kurgartenweg", "Alter Postweg", "Long Turnpike", "Zzyzx Rd.", "Main Street", _
                         "Streetway", "Postplatz", "Beamer Place", "Mercedes Way", "Porsche Drive", _
                         "Weidering", "One Way", "Endof Rd.", "Gotlost Way", "Satnav Rd."}

        Dim locFirstNames As String() = {"Jürgen", "Gabriele", "Dianne", "Katrin", "Jack", _
                    "Arnold", "Christian", "Frank", "Curt", "Peter", "Anne", "Anja", _
                    "Theo", "Bob", "Katrin", "Guido", "Barbara", "Bernhard", "Margarete", _
                    "Alfred", "Melanie", "Britta", "José", "Thomas", "Dara", "Klaus", "Axel", _
                    "Gabby", "Gareth", "Bob", "Denise", "Kristen"}

        Dim locCities As String() = {"Bellevue", "Dortmund", "Lippstadt", "Redmond", _
                    "Los Angeles", "Las Vegas", "Seattle", "New York", "Berlin", "Bielefeld", _
                    "Braunschweig", "Munich", "Cologne", "Hamburg", _
                    "Bad Waldliesborn", "Bremen", "Encinitas", "Anaheim"}

        For i As Integer = 0 To 100
            Dim locLastName, locFirstName As String
            locLastName = locLastNames(locRandom.Next(locLastNames.Length - 1))
            locFirstName = locFirstNames(locRandom.Next(locLastNames.Length - 1))

            LastName(i) = locLastName
            FirstName(i) = locFirstName
            City(i) = locCities(locRandom.Next(locCities.Length - 1))
            ZIP(i) = locRandom.Next(99999).ToString("00000")
        Next
    End Sub
End Module

