﻿Module MainModule

    Dim Contacts(0 To 100) As Contact

    Sub Main()

        'Just for a change...a variation of colors in the Console Window! :-)
        Console.BackgroundColor = ConsoleColor.White
        Console.ForegroundColor = ConsoleColor.Black
        Console.Clear()

        'Generate random addresses.
        Console.Write("Generating random addresses ... ")
        GenerateRandomAddresses()
        Console.WriteLine("Ready!")

        'Print the first 10 addresses.
        PrintAddresses(0, 10)

        'Sort the addresses
        Console.WriteLine()
        Console.Write("Addresses are being sorted ... ")
        SortAddresses()
        Console.WriteLine("ready!")
        Console.WriteLine()

        'Print the first 10 addresses yet again.
        PrintAddresses(0, 10)

        'Wait for the program to be finished.
        Console.WriteLine()
        Console.WriteLine("Press any key...")
        Console.ReadKey()

    End Sub

    Sub PrintAddresses(ByVal from As Integer, ByVal [to] As Integer)
        For c As Integer = from To [to]
            Console.WriteLine(c.ToString("000") & ": " & Contacts(c).LastName & ", " & _
                              Contacts(c).FirstName & ", " & Contacts(c).ZIP & _
                              ", " & Contacts(c).City)
        Next
    End Sub

    Sub SortAddresses()

        Dim ItemsCount As Integer = 101

        Dim outerCounter As Integer
        Dim innerCounter As Integer
        Dim delta As Integer

        Dim tempContact As Contact

        delta = 1

        'Greatest value in distance sequence
        Do
            delta = 3 * delta + 1
        Loop Until delta > ItemsCount

        Do
            delta \= 3

            'Base algorithm of shellsort
            For outerCounter = delta To ItemsCount - 1
                tempContact = Contacts(outerCounter)

                innerCounter = outerCounter
                Do
                    If tempContact.LastName >= Contacts(innerCounter - delta).LastName Then Exit Do
                    Contacts(innerCounter) = Contacts(innerCounter - delta)

                    innerCounter = innerCounter - delta
                    If (innerCounter <= delta) Then Exit Do
                Loop
                Contacts(innerCounter) = tempContact
            Next
        Loop Until delta = 0
    End Sub

    Public Sub GenerateRandomAddresses()

        Dim locRandom As New Random(Now.Millisecond)

        Dim locLastNames As String() = {"Heckhuis", "Löffelmann", "Jones", "Lowel", _
                    "Ardelean", "Beckham", "Baur", "Picard", "Trouv", "Feigenbaum", _
                    "Miller", "Wallace", "Merkel", "Spooner", "Spoonman", "Huffman", _
                    "Rode", "Trouw", "Schindler", "Brown", "Walker", "Cruise", _
                    "Tinoco", "O'Reilly", "O'Donnell", "Ó Briain", "Russel", "English", _
                    "Clarke", "Schumacher"}

        Dim locStreetNames As String() = {"Wiedenbrückerstr.", "Stauffenberg Ave.", "Broadway", "Parkstr.", _
                         "Kurgartenweg", "Alter Postweg", "Long Turnpike", "Zzyzx Rd.", "Main Street", _
                         "Streetway", "Postplatz", "Beamer Place", "Mercedes Way", "Porsche Drive", _
                         "Weidering", "One Way", "Endof Rd.", "Gotlost Way", "Satnav Rd."}

        Dim locFirstNames As String() = {"Jürgen", "Gabriele", "Dianne", "Katrin", "Jack", _
                    "Arnold", "Christian", "Frank", "Curt", "Peter", "Anne", "Anja", _
                    "Theo", "Bob", "Katrin", "Guido", "Barbara", "Bernhard", "Margarete", _
                    "Alfred", "Melanie", "Britta", "José", "Thomas", "Dara", "Klaus", "Axel", _
                    "Gabby", "Gareth", "Bob", "Denise", "Kristen"}

        Dim locCities As String() = {"Bellevue", "Dortmund", "Lippstadt", "Redmond", _
                    "Los Angeles", "Las Vegas", "Seattle", "New York", "Berlin", "Bielefeld", _
                    "Braunschweig", "Munich", "Cologne", "Hamburg", _
                    "Bad Waldliesborn", "Bremen", "Encinitas", "Anaheim"}

        For i As Integer = 0 To 100

            Dim adr As New Contact

            adr.LastName = locLastNames(locRandom.Next(locLastNames.Length - 1))
            adr.FirstName = locFirstNames(locRandom.Next(locFirstNames.Length - 1))
            adr.City = locCities(locRandom.Next(locCities.Length - 1))
            adr.ZIP = locRandom.Next(99999).ToString("00000")
            Contacts(i) = adr
        Next
    End Sub
End Module
