Public Structure NumberSystems

    Private myUnderlyingValue As ULong
    Private myNumberSystem As Integer
    Private Shared myDigits As Char()

    Shared Sub New()
        myDigits = New Char() {"0"c, "1"c, "2"c, "3"c, "4"c, "5"c, "6"c, "7"c, "8"c, "9"c, "A"c, _
                               "B"c, "C"c, "D"c, "E"c, "F"c, "G"c, "H"c, "I"c, "J"c, "K"c, "L"c, _
                               "M"c, "N"c, "O"c, "P"c, "Q"c, "R"c, "S"c, "T"c, "U"c, "V"c, "W"c, _
                               "X"c, "Y"c, "Z"c}
    End Sub

    Sub New(ByVal Value As Integer)
        Me.New(CULng(Value), 16)
    End Sub

    Sub New(ByVal Value As ULong)
        Me.New(Value, 16)
    End Sub

    Sub New(ByVal Value As ULong, ByVal NumberSystem As Integer)
        myUnderlyingValue = Value
        If NumberSystem < 2 OrElse NumberSystem > 33 Then
            Dim up = New OverflowException("Detected number of the numeric systems outside the valid range!")
            'SCRN ;-)
            Throw up
        End If

        myNumberSystem = NumberSystem

    End Sub

    Public Property Value() As ULong

        Get
            Return myUnderlyingValue
        End Get
        Set(ByVal Value As ULong)
            myUnderlyingValue = Value
        End Set

    End Property

    Public Property NumberSystem() As Integer
        Get
            Return myNumberSystem
        End Get

        Set(ByVal Value As Integer)
            If Value < 2 OrElse Value > 33 Then
                Dim BaseNumberSystemException As Exception = New OverflowException _
                ("Identifying number of the numeric systems outside the valid range!")
                Throw BaseNumberSystemException
            End If
            myNumberSystem = Value
        End Set
    End Property

    Public Overrides Function ToString() As String

        Dim locResult As String = ""
        Dim locValue As ULong = myUnderlyingValue

        Do
            Dim digit As Integer = CInt(locValue Mod NumberSystem)
            locResult = CStr(myDigits(digit)) & locResult
            locValue \= CULng(NumberSystem)
        Loop Until locValue = 0

        Return locResult

    End Function

    Public Shared Function Parse(ByVal Value As String, ByVal NumberSystem As Integer) As NumberSystems

        'Here the value is constructed
        Dim locValue As ULong

        For count As Integer = 0 To Value.Length - 1

            Try
                'Current character in the string, which is processed
                Dim locTmpChar As String = Value.Substring(count, 1)

                'Use binary search to find the character in the array and
                'therefore the digit number
                Dim locDigitValue As Integer = CInt(Array.BinarySearch(
                myDigits, CChar(locTmpChar)))

                'Check whether the character is within the valid range
                If locDigitValue >= NumberSystem OrElse locDigitValue < 0 Then
                    Dim BaseNumberSystemException As Exception = New FormatException _
                    ("The number '" & locTmpChar & "' is not part of the " & "numeric system!")
                    Throw BaseNumberSystemException
                End If

                'Create the power of the found digit number and add to the total value
                locValue += CULng(Math.Pow(NumberSystem, Value.Length - count - 1) * locDigitValue)

            Catch ex As Exception
                'In case something goes wrong in between
                Dim up As Exception = New InvalidCastException("The digit of the numeric system is outside the valid range!")
                Throw up
            End Try

            'process next character
        Next

        Return New NumberSystems(locValue, NumberSystem)

    End Function

End Structure
