﻿Option Strict On

'Co-Variance Demo
Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

        'Fill employee with the listing-initializers
        Dim employee As New List(Of Employee) From {
                    New Employee With {.IDEmployee = 1, .LastName = "Leenings", .FirstName = "Ramona"},
                    New Employee With {.IDEmployee = 3, .LastName = "Heckhuis", .FirstName = "Jürgen"},
                    New Employee With {.IDEmployee = 2, .LastName = "Löffelmann", .FirstName = "Klaus"},
                    New Employee With {.IDEmployee = 3, .LastName = "Pusch", .FirstName = "Marcus"},
                    New Employee With {.IDEmployee = 2, .LastName = "Belke", .FirstName = "Andreas"}}

        Dim suppliers As New List(Of suppliers) From {
                    New suppliers With {.IDSupplier = 1, .LastName = "Thiemann", .FirstName = "Uwe"},
                    New suppliers With {.IDSupplier = 2, .LastName = "Löffelmann", .FirstName = "Klaus"},
                    New suppliers With {.IDSupplier = 3, .LastName = "Grauthof", .FirstName = "Kristin"}}

        PrintOutList(employee)
        PrintOutList(suppliers)

        Dim comp As New AddressBaseComparer()

        'Contra-Variance is the opposite case.
        'An Employee is expected for the Comparer,
        'but we're passing an argument of type AddressBase, anyway.
        Dim withoutDoubles = employee.Distinct(comp)
        PrintOutList(withoutDoubles)

    End Sub

    ''' <summary>
    ''' Print out the content of a adressbasic based list
    ''' in the outputwindow (Debug/Windows/Output).
    ''' </summary>
    ''' <param name="adressList">Based on adressbasic List,which is unchangeable.</param>
    ''' <remarks></remarks>
    Sub PrintOutList(ByVal adressList As IEnumerable(Of AddressBase))
        For Each item In adressList
            Debug.Print(item.LastName & ", " & item.FirstName)
        Next
    End Sub

    Sub ThisWontWork()

        ' Dim basicList As List(Of AdressenBasis)
        Dim derivedList As New List(Of Employee)

        'basicList = derivedList

    End Sub

End Class

Public Class AddressBase

    Property FirstName As String
    Property LastName As String

End Class

Public Class Employee
    Inherits AddressBase
    Implements IComparable(Of Employee)

    Property IDEmployee As Integer

    Public Function CompareTo(ByVal other As Employee) As Integer _
        Implements System.IComparable(Of Employee).CompareTo
        Return (Me.LastName & Me.FirstName).CompareTo(other.LastName & other.FirstName)
    End Function

End Class

Public Class suppliers
    Inherits AddressBase

    Property IDSupplier As Integer
End Class

Public Class AddressBaseComparer
    Implements IEqualityComparer(Of AddressBase)

    Public Function Equals1(ByVal x As AddressBase, ByVal y As AddressBase) As Boolean Implements System.Collections.Generic.IEqualityComparer(Of AddressBase).Equals
        If (Object.ReferenceEquals(x, y)) Then Return True

        If (Object.ReferenceEquals(x, Nothing) OrElse
            Object.ReferenceEquals(y, Nothing)) Then
            Return False
        End If

        Return (x.LastName = y.LastName) AndAlso (x.FirstName = y.FirstName)
    End Function

    Public Function GetHashCode1(ByVal obj As AddressBase) As Integer Implements System.Collections.Generic.IEqualityComparer(Of AddressBase).GetHashCode
        If obj Is Nothing Then Return 0

        Dim hashFirstName = If(obj.FirstName Is Nothing, 0, obj.FirstName.GetHashCode)
        Dim hashLastName = If(obj.LastName Is Nothing, 0, obj.LastName.GetHashCode)
        Return hashLastName Xor hashFirstName
    End Function
End Class
