﻿Public Class Form1

    Private myFunction As Func(Of Integer, Double, String) = AddressOf SomeFunction

    Private Function SomeFunction(ByVal par1 As Integer, ByVal par2 As Double) As String
        Return "Result"
    End Function

    'Defines a delegate into a method, which has a parameter of 
    ' the typ object and one of the type EventArgs.
    Private myClickHandler As Action(Of Object, EventArgs)

    Private Sub NightClickHandler(ByVal sender As Object, ByVal e As EventArgs)
        MessageBox.Show("Good night, dear user!" &
                        vbNewLine & "The button has been pressed!")

    End Sub

    Sub New()
        ' The call is required for the Designer.
        InitializeComponent()

        Dim MessageText As String = "Button1 was clicked"
        'Before noon, this Lambda as delegate

        If Now.TimeOfDay < New TimeSpan(12, 0, 0) Then
            'Note: the types of sender and e are derived from
            'the signature of myClickHandler (type inference).
            ' 'as Object' and 'as EventArgs' don't need to be specified.
            myClickHandler = Sub(sender, e)
                                 MessageBox.Show("Good morning, dear User!" &
                                 vbNewLine & MessageText)
                             End Sub

            'Before 6pm, this Lambda as Delegate
        ElseIf Now.TimeOfDay < New TimeSpan(18, 0, 0) Then
            'Here also: Type inference for Lambda parameters.
            myClickHandler = Sub(sender, e)
                                 MessageBox.Show("Good day, dear User!" &
                                 vbNewLine & MessageText)
                             End Sub

        Else
            'Otherwise assign the NightClickHandler Sub to the Action delegate.
            myClickHandler = AddressOf NightClickHandler
        End If

        'Here the Click event is wired
        'which calls the Action delegate.
        AddHandler Button1.Click, Sub(sender, e)
                                      myClickHandler(sender, e)
                                  End Sub
    End Sub

    Sub TupleTest()
        'Defines a new Tuple with three values.
        Dim t As New Tuple(Of Double, Integer, String)(3.1415926, 20, "Test")
        Debug.Print("First value of Tuple:" & t.Item1.ToString)
        Debug.Print("Second value of Tuple:" & t.Item2.ToString)
        Debug.Print("Third value of Tuple:" & t.Item3)
        t = TupleFunction
    End Sub

    Function TupleFunction() As Tuple(Of Double, Integer, String)
        'This function returns three values encapsulated in a Tuple.
        Return New Tuple(Of Double, Integer, String)(3.141592657, 20, "String")
    End Function

End Class
