Public Class Form1

    Private myCheckBoxCondition As Boolean?

    Private myCheckBoxState As Boolean?
    'This would also work:
    'Private myCheckBoxState? As Boolean

    'And this too:
    'Private myCheckBoxState As Nullable(Of Boolean)

    Private Sub btnOK_Click(ByVal sender As System.Object,
                            ByVal e As System.EventArgs) Handles btnOK.Click
        Me.Close()
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, _
                            ByVal e As System.EventArgs) Handles btnSave.Click

        If chkDemo.CheckState = CheckState.Indeterminate Then
            myCheckBoxState = Nothing
        Else
            myCheckBoxState = chkDemo.Checked
        End If

    End Sub

    Private Sub btnRestore_Click(ByVal sender As System.Object, _
                            ByVal e As System.EventArgs) Handles btnRestore.Click

        If Not myCheckBoxState.HasValue Then
            chkDemo.CheckState = CheckState.Indeterminate
        Else
            If myCheckBoxState.Value Then
                chkDemo.CheckState = CheckState.Checked
            Else
                chkDemo.CheckState = CheckState.Unchecked
            End If
        End If
    End Sub

    Public Sub BeCarefulWithNullableBooleanExpressions()

        Dim regularBoolean As Boolean = False
        If regularBoolean Then
            'In this case, if the value is not true, ...
            Console.WriteLine("Value is true!")
        Else
            '... it must be false.
            Console.WriteLine("Value is false!")
        End If

        'Now the value is a nullable boolean and can also be Nothing.
        Dim booleanNullable As Boolean? = Nothing

        If booleanNullable Then
            'Therefore, if the value is not true ...
            MessageBox.Show("Value is true!")
        Else
            '...it does NOT necessarily have to be false!
            MessageBox.Show("Value isn't necessarily false!")
            If Not booleanNullable Then
                'Only here do we know that it was false.
                MessageBox.Show("Value is definitely false!")
            End If
        End If
    End Sub

End Class
