Imports System.IO

Module CollectionsDemo

    Sub Main()
        ArrayListDemo()

        'Decomment these lines to let the other demos run.
        'QueueDemo()
        'StackDemo()
    End Sub

    Sub ArrayListDemo()

        Dim maleNamesList As String() = {"Jrgen", "Uwe", "Klaus", "Christian", "Jos"}
        Dim womenNamesList As New ArrayList
        Dim names As New ArrayList

        'Create ArrayList from the existing array.
        names = New ArrayList(maleNamesList)

        'Fill ArrayList with Add.
        womenNamesList.Add("Adriana") : womenNamesList.Add("Sarika")
        womenNamesList.Add("Kristen") : womenNamesList.Add("Waltraud")
        womenNamesList.Add("Dianne") : womenNamesList.Add("Heidrun")

        'Collection-Initializers:
        Dim dogNamesList As New ArrayList From {"Waldi", "Basko", "Hasso",
                                                     "Wauzi", "Bello", "Minka"}

        'Add ArrayList to an different ArrayList.
        names.AddRange(womenNamesList)

        'Insert ArrayList into an ArrayList.
        Dim dogNames As String() = {"Hasso", "Bello", "Wauzi", "Wuffi", "Basko", "Klaus"}

        'Insert *before* the 6th element
        names.InsertRange(5, dogNames)

        'Convert ArrayList back into an array.
        Dim allNames As String()

        'Attention: Error!
        'allNames = DirectCast(locNamen.ToArray, String())

        'Attention: Another error!
        'allNames = DirectCast(locNamen.ToArray(GetType(String())), String())

        'This is how it works.
        allNames = DirectCast(names.ToArray(GetType(String)), String())

        'Repeat builds an ArrayList from repeated elements.
        names.AddRange(ArrayList.Repeat("Double name", 10))

        'Change an element in the array.
        names(10) = "Fiffi"

        'Its also possible with the Item property:
        names.Item(13) = "Miriam"

        'Deleting the first elements that fits from the list.
        names.Remove("Basko")

        'Deleting an element from a certain position.
        names.RemoveAt(4)

        'Deleting a certain range from the ArrayList.
        'Count determines the number of elements in the ArrayList.
        names.RemoveRange(names.Count - 6, 5)

        'Returning the elements with the Default property of the ArrayList (Item).
        For i As Integer = 0 To names.Count - 1
            Console.WriteLine("Name No. {0} is {1}", i, names(i).ToString)
        Next

        'Add something other than a String object to the ArrayList,
        'to prepare for the following error.
        names.Add(New FileInfo("C:\TEST.TXT"))

        'This loop cannot be run to the end,
        'because there is an object that's not of the type String!
        For Each aString As String In names
            'Here something happens with the string, 
            'which is not important, therefore we don't care of the return value.
            aString.EndsWith("Peter")
        Next

        Console.ReadLine()

    End Sub

    Sub QueueDemo()

        Dim locQueue As New Queue

        'The type-safe Version (based on Generics) is:
        Dim typsafeQueue As New Queue(Of String)

        Dim locString As String

        locQueue.Enqueue("First Element")
        locQueue.Enqueue("Second Element")
        locQueue.Enqueue("Third Element")
        locQueue.Enqueue("Fourth Element")

        'Look up, what's at the beginning without removing it.
        Console.WriteLine("Item at beginning of the queue:" + locQueue.Peek().ToString)
        Console.WriteLine()

        'Iterating does work with queues!
        For Each locString In locQueue
            Console.WriteLine(locString)
        Next
        Console.WriteLine()

        'Remove all items from the queue and show the dequeued items in the console window.
        Do
            locString = CStr(locQueue.Dequeue)
            Console.WriteLine(locString)
        Loop Until locQueue.Count = 0
        Console.ReadLine()

    End Sub

    Sub StackDemo()

        Dim locStack As New Stack

        'The type-safe Version (based on Generics) is:
        Dim typeSafeStack As New Stack(Of String)

        Dim locString As String

        locStack.Push("First element")
        locStack.Push("Second element")
        locStack.Push("Third element")
        locStack.Push("Fourth element")

        'Look up, what's on top of the stack without removing it.
        Console.WriteLine("Topmost item on stack: " + locStack.Peek.ToString)
        Console.WriteLine()

        'Iterating does work with stacks!
        For Each locString In locStack
            Console.WriteLine(locString)
        Next
        Console.WriteLine()

        'Remove all items from the stack and show the removed items in the console window.
        Do
            locString = CStr(locStack.Pop)
            Console.WriteLine(locString)
        Loop Until locStack.Count = 0
        Console.ReadLine()

    End Sub

End Module

