Module Enumerators

    Sub Main()

        'This wouldn't work:
        'for d as Date=#24/12/2004# to #31/12/2004
        '    Console.WriteLine("Date in enumeration: {0}", d)
        'Next d


        Dim locDatumsaufzhlung As New DateEnumeration(#7/24/2010#, #8/4/2010#,
                                                        New TimeSpan(1, 0, 0, 0))
        For Each d As Date In locDatumsaufzhlung
            Console.WriteLine("Date in enumeration: {0}", d)
        Next

        Console.ReadLine()

    End Sub

End Module

Public Class DateEnumeration
    Implements IEnumerable

    Dim locDateEnumerator As DateEnumerator

    Sub New(ByVal StartDate As Date, ByVal EndDate As Date, ByVal [Step] As TimeSpan)
        locDateEnumerator = New DateEnumerator(StartDate, EndDate, [Step])
    End Sub

    Public Function GetEnumerator() As System.Collections.IEnumerator _
                    Implements System.Collections.IEnumerable.GetEnumerator
        Return locDateEnumerator
    End Function
End Class

Public Class DateEnumerator
    Implements IEnumerator

    Private myCurrentDate As Date

    Sub New(ByVal startDate As Date, ByVal endDate As Date, ByVal [step] As TimeSpan)
        Me.startDate = startDate
        Me.endDate = endDate
        Me.[step] = [step]
        myCurrentDate = startDate
    End Sub

    Public Property startDate() As Date
    Public Property endDate() As Date
    Public Property [step]() As TimeSpan

    Public ReadOnly Property Current() As Object Implements System.Collections.IEnumerator.Current
        Get
            Return myCurrentDate
        End Get
    End Property

    Public Function MoveNext() As Boolean Implements System.Collections.IEnumerator.MoveNext
        myCurrentDate = myCurrentDate.Add([step])
        If myCurrentDate > endDate Then
            Return False
        Else
            Return True
        End If
    End Function

    Public Sub Reset() Implements System.Collections.IEnumerator.Reset
        myCurrentDate = startDate
    End Sub
End Class
