Module HashtableDemo

Sub Main()
        'For the further examples uncomment the following three lines.
        'TestAddresses()
        'Console.ReadLine()
        'Return

        Dim locNumberAddresses As Integer = 1000000
        Dim locAccessElements As Integer = 2
        Dim locMeasurements As Integer = 3
        Dim locAccesses As Integer = 1000000
        Dim locTemplateAddresses As ArrayList
        Dim locAddresses As New Hashtable
        Dim locTestKeys(locAccessElements) As String
        Dim locRandom As New Random(Now.Millisecond)

        'Waiting for start
        Console.WriteLine("Press Enter to start")
        Console.ReadLine()

        'Generate many addresses:
        Console.Write("Creating {0} random address entries...", locNumberAddresses)

        Dim locTimer = Stopwatch.StartNew
        locTemplateAddresses = Address.RandomAddresses(locNumberAddresses)
        locTimer.Stop()

        Console.WriteLine("finished after {0} ms", locTimer.ElapsedMilliseconds)

        locTimer.Reset()

        'Building the hashtable
        Console.Write("Building the hashtable with random address entries...", locNumberAddresses)
        locTimer.Start()
        For Each address As Address In locTemplateAddresses
            locAddresses.Add(address.Matchcode, address)
        Next

        locTimer.Stop()

        Console.WriteLine("finished after {0} ms", locTimer.ElapsedMilliseconds)
        locTimer.Reset()

        'Pick n random addresses
        For i As Integer = 0 To locAccessElements
            locTestKeys(i) = DirectCast(locTemplateAddresses(
            locRandom.Next(locNumberAddresses)), Address).Matchcode
        Next

        Dim locTemp As Object
        Dim locTemp2 As Object = Nothing

        'Accessing, and measuring how long it takes.
        'Do it 5 times to confirm the measurement.
        For z As Integer = 1 To locMeasurements
            Console.WriteLine()
            Console.WriteLine("{0}. Measurement:", z)
            For i As Integer = 0 To locAccessElements
                Console.Write("{0} accesses to: {1} in ", locAccesses,
                locTestKeys(i))
                locTemp = locTestKeys(i)
                locTimer.Start()
                For j As Integer = 1 To locAccesses
                    locTemp2 = locAddresses(locTemp)
                Next j
                locTimer.Stop()
                locTemp = locTemp2.GetType
                Console.WriteLine("{0} ms", locTimer.ElapsedMilliseconds)
                locTimer.Reset()
            Next
        Next

        'Access to Arraylist for comparison
        For i As Integer = 0 To locAccessElements
            Console.Write("{0} accesses to ArrayList element in ", locAccesses)
            locTimer.Start()
            For j As Integer = 1 To locAccesses
                locTemp2 = locTemplateAddresses(0)
            Next j
            locTimer.Stop()
            locTemp = locTemp2.GetType
            Console.WriteLine("{0} ms", locTimer.ElapsedMilliseconds)
            locTimer.Reset()
        Next

        Console.ReadLine()

    End Sub

    Sub TestAddresses()

        'Create 15 random addresses.
        Dim locDemoAddresses As ArrayList = Address.RandomAddresses(15)

        'Output addresses in the console window.
        Console.WriteLine("List with random personal data")
        Console.WriteLine(New String("="c, 30))
        Address.OutputAddresses(locDemoAddresses)

    End Sub
End Module


