Module HashtableDemo

    Sub Main()

        Dim locNumberAddresses As Integer = 1000000
        Dim locAccessElements As Integer = 50
        Dim locMeasurements As Integer = 3
        Dim locAccesses As Integer = 1000000
        Dim locTemplateAddresses As ArrayList
        Dim locAddresses As New Hashtable(100000, 0.1)
        Dim locTestKeys(locAccessElements) As AddressesKey
        Dim locRandom As New Random(Now.Millisecond)

        'Waiting for start
        Console.WriteLine("Press Enter to start")
        Console.ReadLine()

        'Generate many addresses:
        Console.Write("Creating {0} random address entries...", locNumberAddresses)
        Dim locTimer = Stopwatch.StartNew
        locTemplateAddresses = Address.RandomAddresses(locNumberAddresses)
        locTimer.Stop()

        Console.WriteLine("finished after {0} ms", locTimer.ElapsedMilliseconds)
        locTimer.Reset()

        'Building the hashtable
        Console.Write("Building the hashtable with random address entries...", locNumberAddresses)

        locTimer.Start()

        For Each address As Address In locTemplateAddresses
            'Change: Don't use the string, but a Key object instead
            locAddresses.Add(New AddressesKey(address.Matchcode), address)
        Next

        locTimer.Stop()

        Console.WriteLine("finished after {0} ms", locTimer.ElapsedMilliseconds)
        locTimer.Reset()

        'Pick 51 random addresses.
        'Change: The keys are saved, but not the Matchcode
        For i As Integer = 0 To locAccessElements
            locTestKeys(i) = New AddressesKey(
            DirectCast(locTemplateAddresses(locRandom.Next(
            locNumberAddresses)), Address).Matchcode)
        Next

        'Change: No more object, but instead directly an AddressesKey
        Dim locTemp As AddressesKey
        Dim locTemp2, locTemp3 As Object

        'Access and measure how long it takes
        'Do it 5 times to confirm the measurement.
        For z As Integer = 1 To locMeasurements
            Console.WriteLine()
            Console.WriteLine("{0}. Measurement:", z)
            For i As Integer = 0 To locAccessElements
                Console.Write("{0} accesses to: {1} in ", locAccesses,
                locTestKeys(i))
                locTemp = locTestKeys(i)
                locTimer.Start()
                For j As Integer = 1 To locAccesses
                    locTemp2 = locAddresses(locTemp)
                Next j
                locTimer.Stop()
                'Better is better: Avoid that the compiler notices
                'that locTemp2 is not necessary, and it is optimized out!
                locTemp3 = locTemp2.GetType
                Console.WriteLine("{0} ms", locTimer.ElapsedMilliseconds)
                locTimer.Reset()
            Next

            'Access to Arraylist for comparison
            For i As Integer = 0 To locAccessElements
                Console.Write("{0} accesses to ArrayList element in ", locAccesses)
                locTimer.Start()
                For j As Integer = 1 To locAccesses
                    locTemp2 = locTemplateAddresses(0)
                Next j
                locTimer.Stop()
                Console.WriteLine("{0} ms", locTimer.ElapsedMilliseconds)
                locTimer.Reset()
            Next

            Console.ReadLine()

        Next

        Console.ReadLine()
        Return

        'How to: Iterating through a HashTable
        For Each locDE As DictionaryEntry In locAddresses
            'getting the key,
            Dim locAdressenKey = DirectCast(locDE.Key, AddressesKey)
            'and the object alternatively.
            Dim locAdresse = DirectCast(locDE.Value, Address)
        Next
    End Sub
End Module
