Module ComparerSample

    Sub Main()
        Dim someAddresses(5) As Address

        someAddresses(0) = New Address("Ardelean", "Adriana", "90820", "Encinitas CA")
        someAddresses(1) = New Address("Lffelmann", "Klaus", "90210", "Encinitas CA")
        someAddresses(2) = New Address("Heckhuis", "Jrgen", "90210", "Los Angeles CA")
        someAddresses(3) = New Address("Hora", "Cate", "90210", "Pompano Beach FL")
        someAddresses(4) = New Address("Hora", "Oli", "90210", "Pompano Beach FL")
        someAddresses(5) = New Address("Merkel", "Angela", "54923", "Berlin WI")

        Console.WriteLine("List of addresses:")
        Console.WriteLine(New String("="c, 40))
        PrintAddresses(someAddresses)

        Console.WriteLine()
        Console.WriteLine("List of addresses (sorted):")
        Console.WriteLine(New String("="c, 40))
        'Array.Sort(someAddresses)

        PrintAddresses(someAddresses)

        Console.ReadLine()
    End Sub

    Sub PrintAddresses(ByVal Adress As Address())
        For Each locString As Address In Adress
            Console.WriteLine(locString)
        Next
    End Sub

End Module

Public Class Address
    Implements IComparable

    Sub New(ByVal LastName As String, ByVal FirstName As String, _
            ByVal Zip As String, ByVal CityAndCountryCode As String)
        Me.LastName = LastName
        Me.FirstName = FirstName
        Me.Zip = Zip
        Me.CityAndCountryCode = CityAndCountryCode
    End Sub

    'Auto-Implemented Properties
    Public Property LastName() As String
    Public Property FirstName() As String
    Public Property CityAndCountryCode() As String
    Public Property Zip() As String

    Public Overrides Function ToString() As String
        Return LastName + ", " + FirstName + ", " + Zip + " " + CityAndCountryCode
    End Function

    Public Function CompareTo(ByVal obj As Object) As Integer Implements System.IComparable.CompareTo

        Dim locAdresse As Address

        Try
            locAdresse = DirectCast(obj, Address)
        Catch ex As InvalidCastException
            Dim up As New InvalidCastException("'CompareTo' of class 'Address' cannot be compared " + _
                                               "with objects of different tz!")
            Throw up
        End Try
        Return ToString.CompareTo(locAdresse.ToString)
    End Function
End Class