Imports System.IO

Module TypesafeCollections

    Sub Main()
        Dim locAddresses As New Addresses
        Dim locAdresse As New Address("Christian", "Sonntag", "99999", "Munich")
        Dim locAndererTyp As New FileInfo("C:\Test.txt")

        'No problemo:
        locAddresses.Add(locAdresse)

        'Already, the editor whines:
        'locAdressen.Add(locAndererTyp)

        'Not a problem, either:
        locAdresse = locAddresses(0)

        For Each aAddress As Address In locAddresses
            Console.WriteLine(aAddress)
        Next
        Console.ReadLine()
    End Sub

End Module

Public Class Addresses
    Inherits CollectionBase

    Public Overridable Function Add(ByVal Adr As Address) As Integer
        Return MyBase.List.Add(Adr)
    End Function

    Default Public Overridable Property Item(ByVal Index As Integer) As Address
        Get
            Return DirectCast(MyBase.List(Index), Address)
        End Get
        Set(ByVal Value As Address)
            MyBase.List(Index) = Value
        End Set
    End Property
End Class

Public Class Address
    Implements IComparable


    Sub New(ByVal LastName As String, ByVal FirstName As String, ByVal ZIP As String, ByVal City As String)
        LastName = LastName
        FirstName = FirstName
        ZIP = ZIP
        City = City
    End Sub

    Public Property LastName() As String
    Public Property FirstName() As String
    Public Property ZIP() As String
    Public Property City() As String

    Public Overrides Function ToString() As String
        Return LastName + ", " + FirstName + ", " + ZIP + " " + City
    End Function

    Public Function CompareTo(ByVal obj As Object) As Integer Implements System.IComparable.CompareTo

        Dim locAdresse As Address

        Try
            locAdresse = DirectCast(obj, Address)
        Catch ex As InvalidCastException
            Dim up As New InvalidCastException("'CompareTo' of class 'Address' cannot compare " + _
                                               "objects of different type!")
            Throw up
        End Try
        Return ToString.CompareTo(locAdresse.ToString)
    End Function
End Class

'----------------------------------------------------------------------------------------
'--Just for further explanation purposes - doesn't have to do with the actual program! --
'----------------------------------------------------------------------------------------
Interface ITest
    Function Add(ByVal obj As Object) As Integer
End Interface

MustInherit Class ITestClass
    Implements ITest

    Private Function ITestAdd(ByVal obj As Object) As Integer Implements ITest.Add
        Trace.WriteLine("ITestAdd:" + obj.ToString)
    End Function

End Class

Class ITestClassDerived
    Inherits ITestClass

    Public ReadOnly Property Test() As ITest
        Get
            Return DirectCast(Me, ITest)
        End Get
    End Property

    Public Sub Add(ByVal TypeSafe As Address)
        Test.Add(TypeSafe)
    End Sub
End Class
