Imports System.Reflection
Imports System.IO

Module mdlMain

    Sub Main()

        Dim locAddress As New Address("Adriana", "Ardelean", "Book Ave. 100", "De 32154 Publisher Valley") With
            {.IsFriendWith = New List(Of Address) From
                {New Address("Klaus", "Lffelmann", "One Microsoft Way", "WA 99999 Redmond")}}

        PrintObjectInfo(locAddress)
        Console.ReadLine()

    End Sub

    Sub PrintObjectInfo(ByVal [Object] As Object)

        'Find out the object type to access the object content
        Dim locTypeInstanz As Type = [Object].GetType

        'Return the attributes that are not custom:
        Console.WriteLine("Attributes of class:" + locTypeInstanz.FullName)
        Console.WriteLine("Standard attributes:")
        Console.WriteLine("    *" + locTypeInstanz.Attributes.ToString())
        Console.WriteLine()

        'Determine custom attributes of the class
        '(*Only* custom attributes can be determined this way)
        Console.WriteLine("Custom attributes:")
        For Each locAttribute As Attribute In locTypeInstanz.GetCustomAttributes(True)
            Console.WriteLine("    * " + locAttribute.ToString())
        Next
        Console.WriteLine()

        'Find out members and their possible optional attributes
        Dim locMembers() As MemberInfo
        locMembers = locTypeInstanz.GetMembers()
        Console.WriteLine("List of members:")
        For Each locMember As MemberInfo In locMembers
            Console.WriteLine("    *" + locMember.Name + ", " _
                                + locMember.MemberType.ToString)

            If locMember.GetCustomAttributes(True).Length > 0 Then
                Console.WriteLine("     " + New String("-"c, locMember.Name.Length))
                For Each locAttribute As Attribute In locMember.GetCustomAttributes(False)
                    Console.WriteLine("         * " + locAttribute.ToString())
                    For Each locPropertyInfo As PropertyInfo In locAttribute.GetType.GetProperties
                        Console.Write("          " + locPropertyInfo.Name)
                        Console.WriteLine(": " + locPropertyInfo.GetValue(locAttribute, Nothing).ToString)
                    Next
                Next
            End If

            If locMember.MemberType = MemberTypes.Property Then
                Dim locPropertyInfo As PropertyInfo = CType(locMember, PropertyInfo)
                Console.WriteLine("     Value: " + locPropertyInfo.GetValue([Object], Nothing).ToString)
            End If
        Next
    End Sub

End Module

<Serializable(), ThatsMy("Above the class")>
Public Class Address

    Sub New()
        MyBase.New()
    End Sub

    Private myDateCreated As DateTime
    Private myCreatedBy As String

    <ThatsMy("Above the constructor")>
    Sub New(ByVal FirstName As String, ByVal LastName As String, ByVal Street As String, ByVal ZipCity As String)
        Me.LastName = LastName
        Me.FirstName = FirstName
        Me.Street = Street
        Me.ZipCity = ZipCity
        myDateCreated = DateTime.Now
        myCreatedBy = Environment.UserName
    End Sub

    <ThatsMy("Above a property")>
    Public Property LastName() As String
    Public Property FirstName() As String
    Public Property Street() As String
    Public Property ZipCity() As String
    Public Property IsFriendWith() As List(Of Address)

    Public ReadOnly Property DateCreated() As DateTime
        Get
            Return myDateCreated
        End Get
    End Property

    Public ReadOnly Property CreatedBy() As String
        Get
            Return myCreatedBy
        End Get
    End Property

    <ThatsMy("Above a method")>
    Public Overrides Function ToString() As String
        Dim locTemp As String
        locTemp = LastName + ", " + FirstName + ", " + Street + ", " + ZipCity + vbNewLine
        locTemp += "--- Is friend with: ---" + vbNewLine
        For Each locAdr As Address In IsFriendWith
            locTemp += "   * " + locAdr.ToShortString() + vbNewLine
        Next
        locTemp += vbNewLine
        Return locTemp
    End Function

    Public Function ToShortString() As String
        Return LastName + ", " + FirstName
    End Function
End Class

'Create custom Attribute
<AttributeUsage(AttributeTargets.All)>
Public Class ThatsMyAttribute
    Inherits Attribute
    Private myName As String

    Public Sub New(ByVal name As String)
        myName = name
    End Sub 'New

    Public ReadOnly Property Name() As String
        Get
            Return myName
        End Get
    End Property
End Class
