
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 07/06/2011 17:46:27
-- Generated from EDMX file: C:\Users\andreasb\Documents\Visual Studio 2010\Projects\ModelFirst\ModelFirst\ModelFirst.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [myNewDatabase];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_EmployeeProject_Employee]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EmployeeProject] DROP CONSTRAINT [FK_EmployeeProject_Employee];
GO
IF OBJECT_ID(N'[dbo].[FK_EmployeeProject_Project]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[EmployeeProject] DROP CONSTRAINT [FK_EmployeeProject_Project];
GO
IF OBJECT_ID(N'[dbo].[FK_EmployeeProject1]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Project] DROP CONSTRAINT [FK_EmployeeProject1];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Employee]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Employee];
GO
IF OBJECT_ID(N'[dbo].[Project]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Project];
GO
IF OBJECT_ID(N'[dbo].[EmployeeProject]', 'U') IS NOT NULL
    DROP TABLE [dbo].[EmployeeProject];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Employee'
CREATE TABLE [dbo].[Employee] (
    [EmployeeID] int IDENTITY(1,1) NOT NULL,
    [LastName] nvarchar(max)  NOT NULL,
    [FirstName] nvarchar(max)  NOT NULL,
    [Birthday] datetime  NOT NULL,
    [CreatedOn] datetime  NOT NULL
);
GO

-- Creating table 'Project'
CREATE TABLE [dbo].[Project] (
    [ProjectID] int IDENTITY(1,1) NOT NULL,
    [Description] nvarchar(max)  NOT NULL,
    [CostCenter] smallint  NOT NULL,
    [Manager_EmployeeID] int  NOT NULL
);
GO

-- Creating table 'EmployeeProject'
CREATE TABLE [dbo].[EmployeeProject] (
    [Employees_EmployeeID] int  NOT NULL,
    [WorksOn_ProjectID] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [EmployeeID] in table 'Employee'
ALTER TABLE [dbo].[Employee]
ADD CONSTRAINT [PK_Employee]
    PRIMARY KEY CLUSTERED ([EmployeeID] ASC);
GO

-- Creating primary key on [ProjectID] in table 'Project'
ALTER TABLE [dbo].[Project]
ADD CONSTRAINT [PK_Project]
    PRIMARY KEY CLUSTERED ([ProjectID] ASC);
GO

-- Creating primary key on [Employees_EmployeeID], [WorksOn_ProjectID] in table 'EmployeeProject'
ALTER TABLE [dbo].[EmployeeProject]
ADD CONSTRAINT [PK_EmployeeProject]
    PRIMARY KEY NONCLUSTERED ([Employees_EmployeeID], [WorksOn_ProjectID] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [Employees_EmployeeID] in table 'EmployeeProject'
ALTER TABLE [dbo].[EmployeeProject]
ADD CONSTRAINT [FK_EmployeeProject_Employee]
    FOREIGN KEY ([Employees_EmployeeID])
    REFERENCES [dbo].[Employee]
        ([EmployeeID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [WorksOn_ProjectID] in table 'EmployeeProject'
ALTER TABLE [dbo].[EmployeeProject]
ADD CONSTRAINT [FK_EmployeeProject_Project]
    FOREIGN KEY ([WorksOn_ProjectID])
    REFERENCES [dbo].[Project]
        ([ProjectID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmployeeProject_Project'
CREATE INDEX [IX_FK_EmployeeProject_Project]
ON [dbo].[EmployeeProject]
    ([WorksOn_ProjectID]);
GO

-- Creating foreign key on [Manager_EmployeeID] in table 'Project'
ALTER TABLE [dbo].[Project]
ADD CONSTRAINT [FK_EmployeeProject1]
    FOREIGN KEY ([Manager_EmployeeID])
    REFERENCES [dbo].[Employee]
        ([EmployeeID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_EmployeeProject1'
CREATE INDEX [IX_FK_EmployeeProject1]
ON [dbo].[Project]
    ([Manager_EmployeeID]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------